diff --git a/content/content_renderer.gypi b/content/content_renderer.gypi
index 4cfd238..253885b 100644
--- a/content/content_renderer.gypi
+++ b/content/content_renderer.gypi
@@ -269,6 +269,12 @@
       'renderer/media/crypto/ppapi_decryptor.h',
       'renderer/media/crypto/render_cdm_factory.cc',
       'renderer/media/crypto/render_cdm_factory.h',
+      'renderer/media/gstreamer/webmediaplayer_gstreamer.cc',
+      'renderer/media/gstreamer/webmediaplayer_gstreamer.h',
+      'renderer/media/gstreamer/webmediasource_gstreamer.cc',
+      'renderer/media/gstreamer/webmediasource_gstreamer.h',
+      'renderer/media/gstreamer/websourcebuffer_gstreamer.cc',
+      'renderer/media/gstreamer/websourcebuffer_gstreamer.h',
       'renderer/media/media_permission_dispatcher.cc',
       'renderer/media/media_permission_dispatcher.h',
       'renderer/media/media_stream_audio_level_calculator.cc',
@@ -731,6 +737,43 @@
           '../base/allocator/allocator.gyp:allocator',
       ],
     }],
+    ['use_gstreamer==1', {
+      'sources': [
+          '../media/blink/cdm_result_promise.h',
+          '../media/blink/cdm_result_promise_helper.cc',
+          '../media/blink/cdm_result_promise_helper.h',
+          '../media/blink/cdm_session_adapter.cc',
+          '../media/blink/cdm_session_adapter.h',
+          '../media/blink/webcontentdecryptionmodule_impl.cc',
+          '../media/blink/webcontentdecryptionmodule_impl.h',
+          '../media/blink/webcontentdecryptionmoduleaccess_impl.cc',
+          '../media/blink/webcontentdecryptionmoduleaccess_impl.h',
+          '../media/blink/webcontentdecryptionmodulesession_impl.cc',
+          '../media/blink/webcontentdecryptionmodulesession_impl.h',
+          '../media/blink/webencryptedmediaclient_impl.cc',
+          '../media/blink/webencryptedmediaclient_impl.h',
+          '../media/blink/encrypted_media_player_support.cc',
+          '../media/blink/encrypted_media_player_support.h',
+          '../media/blink/new_session_cdm_result_promise.cc',
+          '../media/blink/new_session_cdm_result_promise.h',
+          '../media/blink/texttrack_impl.cc',
+          '../media/blink/texttrack_impl.h',
+          '../media/blink/webinbandtexttrack_impl.cc',
+          '../media/blink/webinbandtexttrack_impl.h',
+      ],
+      'defines': [
+        'MEDIA_IMPLEMENTATION',
+      ],
+    }, {
+      'sources!': [
+        'renderer/media/gstreamer/webmediaplayer_gstreamer.cc',
+        'renderer/media/gstreamer/webmediaplayer_gstreamer.h',
+        'renderer/media/gstreamer/webmediasource_gstreamer.cc',
+        'renderer/media/gstreamer/webmediasource_gstreamer.h',
+        'renderer/media/gstreamer/websourcebuffer_gstreamer.cc',
+        'renderer/media/gstreamer/websourcebuffer_gstreamer.h',
+      ],
+    }],
     ['OS=="android"', {
       'sources!': [
         'renderer/media/audio_decoder.cc',
diff --git a/content/media/gstreamer/gpuprocess/client_egl.cc b/content/media/gstreamer/gpuprocess/client_egl.cc
new file mode 100644
index 0000000..39ef44b
--- /dev/null
+++ b/content/media/gstreamer/gpuprocess/client_egl.cc
@@ -0,0 +1,162 @@
+// Copyright 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "content/media/gstreamer/gpuprocess/client_egl.h"
+
+#include <vector>
+
+#include "base/lazy_instance.h"
+#include "content/common/gpu/client/command_buffer_proxy_impl.h"
+#include "gpu/command_buffer/client/gpu_control.h"
+#include "gpu/command_buffer/client/gles2_implementation.h"
+#include "gpu/command_buffer/client/gles2_interface.h"
+#include "gpu/command_buffer/client/gles2_lib.h"
+
+#include <EGL/egl.h>
+#include <EGL/eglext.h>
+
+namespace content {
+
+static base::LazyInstance<CommandBufferProxyImpl*>
+    g_thread_safe_cmd_impl = LAZY_INSTANCE_INITIALIZER;
+
+bool ClientEGL_SetupCommandBufferProxy()
+{
+  gpu::gles2::GLES2Interface* gl_interface = ::gles2::GetGLContext();
+
+  if (!gl_interface) {
+    NOTREACHED() << "clientEglSetCommandBufferProxy, no gl interface";
+    return false;
+  }
+
+  gpu::gles2::GLES2Implementation* gl_impl =
+      reinterpret_cast<gpu::gles2::GLES2Implementation*>(gl_interface);
+
+  if (!gl_impl) {
+    NOTREACHED() << "clientEglSetCommandBufferProxy, no gles impl";
+    return false;
+  }
+
+  gpu::GpuControl* gpu_ctrl = gl_impl->gpu_control();
+
+  if (!gpu_ctrl) {
+    NOTREACHED() << "ClientEGL_SetupCommandBufferProxy, no gpu control";
+    return false;
+  }
+
+  if (gpu_ctrl->IsGpuChannelLost()) {
+    NOTREACHED() << "ClientEGL_SetupCommandBufferProxy, gpu channel is lost";
+    return false;
+  }
+
+  content::CommandBufferProxyImpl* cmd_impl =
+      static_cast<content::CommandBufferProxyImpl*>(gpu_ctrl);
+
+  if (!cmd_impl) {
+    NOTREACHED() << "ClientEGL_SetupCommandBufferProxy, no cmd buffer proxy";
+    return false;
+  }
+
+  g_thread_safe_cmd_impl.Get() = cmd_impl;
+
+  return true;
+}
+
+EGLImageKHR CreateEGLImageKHR(EGLDisplay dpy,
+                              EGLContext ctx,
+                              EGLenum target,
+                              EGLClientBuffer buffer,
+                              const EGLint* attrib_list) {
+  if (!g_thread_safe_cmd_impl.Get()) {
+    NOTREACHED() << "eglCreateImageKHR, no cmd buffer proxy";
+    return EGL_NO_IMAGE_KHR;
+  }
+
+  if (ctx != EGL_NO_CONTEXT) {
+    NOTREACHED() << "eglCreateImageKHR, ctx != EGL_NO_CONTEXT";
+    return EGL_NO_IMAGE_KHR;
+  }
+
+  if (target != EGL_LINUX_DMA_BUF_EXT) {
+    NOTREACHED() << "eglCreateImageKHR, target != EGL_LINUX_DMA_BUF_EXT";
+    return EGL_NO_IMAGE_KHR;
+  }
+
+  if (buffer != static_cast<EGLClientBuffer>(nullptr)) {
+    NOTREACHED() << "eglCreateImageKHR, Client buffer must be null";
+    return EGL_NO_IMAGE_KHR;
+  }
+
+  if (!attrib_list) {
+    NOTREACHED() << "eglCreateImageKHR, attrib_list is null";
+    return EGL_NO_IMAGE_KHR;
+  }
+
+  // Retrieve width, height and number of attributes.
+  GLsizei width = 0;
+  GLsizei height = 0;
+  size_t nb_attribs = 0;
+  std::vector<int32_t> dmabuf_fds;
+
+  for (size_t i = 0; i < 20; ++i) {
+    if (attrib_list[i] == EGL_WIDTH)
+      width = attrib_list[i + 1];
+    else if (attrib_list[i] == EGL_HEIGHT)
+      height = attrib_list[i + 1];
+    else if (attrib_list[i] == EGL_DMA_BUF_PLANE0_FD_EXT ||
+             attrib_list[i] == EGL_DMA_BUF_PLANE1_FD_EXT ||
+             attrib_list[i] == EGL_DMA_BUF_PLANE2_FD_EXT)
+      dmabuf_fds.push_back(attrib_list[i + 1]);
+    else if (attrib_list[i] == EGL_NONE) {
+      nb_attribs = i + 1;
+      break;
+    }
+  }
+
+  if (!nb_attribs) {
+    NOTREACHED() << "eglCreateImageKHR, no attribs";
+    return EGL_NO_IMAGE_KHR;
+  }
+
+  if (width <= 0) {
+    NOTREACHED() << "eglCreateImageKHR, width <= 0";
+    return EGL_NO_IMAGE_KHR;
+  }
+
+  if (height <= 0) {
+    NOTREACHED() << "eglCreateImageKHR, height <= 0";
+    return EGL_NO_IMAGE_KHR;
+  }
+
+  int32_t image_id = g_thread_safe_cmd_impl.Get()->CreateEGLImage(
+      width, height,
+      std::vector<int32_t>(attrib_list, attrib_list + nb_attribs), dmabuf_fds);
+
+  if (image_id < 0) {
+    NOTREACHED() << "eglCreateImageKHR, image_id < 0";
+    return EGL_NO_IMAGE_KHR;
+  }
+
+  return reinterpret_cast<EGLImageKHR>(image_id);
+}
+
+EGLBoolean DestroyEGLImageKHR(EGLDisplay dpy, EGLImageKHR img) {
+  gpu::gles2::GLES2Interface* gl = ::gles2::GetGLContext();
+
+  if (!gl) {
+    NOTREACHED() << "eglDestroyEGLImageKHR, no gl interface";
+    return EGL_FALSE;
+  }
+
+  if (img == EGL_NO_IMAGE_KHR) {
+    NOTREACHED() << "eglDestroyEGLImageKHR, invalid egl image";
+    return EGL_FALSE;
+  }
+
+  gl->DestroyImageCHROMIUM(reinterpret_cast<uintptr_t>(img));
+
+  return EGL_TRUE;
+}
+
+}  // namespace content
diff --git a/content/media/gstreamer/gpuprocess/client_egl.h b/content/media/gstreamer/gpuprocess/client_egl.h
new file mode 100644
index 0000000..4190cf5
--- /dev/null
+++ b/content/media/gstreamer/gpuprocess/client_egl.h
@@ -0,0 +1,30 @@
+// Copyright 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_MEDIA_GSTREAMER_GPUPROCESS_CLIENT_EGL_H_
+#define CONTENT_MEDIA_GSTREAMER_GPUPROCESS_CLIENT_EGL_H_
+
+namespace content {
+
+typedef unsigned int EGLBoolean;
+typedef unsigned int EGLenum;
+typedef void* EGLDisplay;
+typedef void* EGLContext;
+typedef void* EGLClientBuffer;
+typedef int EGLint;
+typedef void* EGLImageKHR;
+
+bool ClientEGL_SetupCommandBufferProxy();
+
+EGLImageKHR CreateEGLImageKHR(EGLDisplay dpy,
+                              EGLContext ctx,
+                              EGLenum target,
+                              EGLClientBuffer buffer,
+                              const EGLint* attrib_list);
+
+EGLBoolean DestroyEGLImageKHR(EGLDisplay dpy, EGLImageKHR img);
+
+}  // namespace content
+
+#endif  // CONTENT_MEDIA_GSTREAMER_GPUPROCESS_CLIENT_EGL_H_
diff --git a/content/media/gstreamer/gpuprocess/gstglcontext_gpu_process.c b/content/media/gstreamer/gpuprocess/gstglcontext_gpu_process.c
new file mode 100644
index 0000000..545dad3
--- /dev/null
+++ b/content/media/gstreamer/gpuprocess/gstglcontext_gpu_process.c
@@ -0,0 +1,147 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include "content/media/gstreamer/gpuprocess/gstglcontext_gpu_process.h"
+#include "content/media/gstreamer/gpuprocess/gstglwindow_gpu_process.h"
+
+#define GST_GL_CONTEXT_GPU_PROCESS_GET_PRIVATE(o)  \
+  (G_TYPE_INSTANCE_GET_PRIVATE((o), GST_GL_TYPE_CONTEXT_GPU_PROCESS, GstGLContextGPUProcessPrivate))
+
+#define GST_CAT_DEFAULT gst_gl_context_debug
+
+#define gst_gl_context_gpu_process_parent_class parent_class
+G_DEFINE_TYPE (GstGLContextGPUProcess, gst_gl_context_gpu_process,
+    GST_GL_TYPE_CONTEXT_EGL);
+
+struct _GstGLContextGPUProcessPrivate
+{
+  // Nothing for now;
+  gint empty;
+};
+
+static guintptr
+gst_gl_context_gpu_process_get_gl_context (GstGLContext * context)
+{
+  return 0;
+}
+
+static GstGLAPI
+gst_gl_context_gpu_process_get_gl_api (GstGLContext * context)
+{
+  return GST_GL_CONTEXT_EGL (context)->gl_api;
+}
+
+static GstGLPlatform
+gst_gl_context_gpu_process_get_gl_platform (GstGLContext * context)
+{
+  return 0;
+}
+
+static gboolean
+gst_gl_context_gpu_process_activate (GstGLContext * context, gboolean activate)
+{
+  return TRUE;
+}
+
+static void
+gst_gl_context_gpu_process_finalize (GObject * object)
+{
+  GstGLContext *context = GST_GL_CONTEXT (object);
+
+  if (context->window)
+    GST_GL_WINDOW_GET_CLASS (context->window)->close (context->window);
+
+  G_OBJECT_CLASS (parent_class)->finalize (object);
+}
+
+static void
+gst_gl_context_gpu_process_class_init (GstGLContextGPUProcessClass * klass)
+{
+  GObjectClass *obj_class = G_OBJECT_CLASS (klass);
+  GstGLContextClass *context_class = (GstGLContextClass *) klass;
+
+  g_type_class_add_private (klass, sizeof (GstGLContextGPUProcessPrivate));
+
+  obj_class->finalize = gst_gl_context_gpu_process_finalize;
+
+  context_class->get_gl_context =
+      GST_DEBUG_FUNCPTR (gst_gl_context_gpu_process_get_gl_context);
+  context_class->get_gl_api =
+      GST_DEBUG_FUNCPTR (gst_gl_context_gpu_process_get_gl_api);
+  context_class->get_gl_platform =
+      GST_DEBUG_FUNCPTR (gst_gl_context_gpu_process_get_gl_platform);
+  context_class->activate =
+      GST_DEBUG_FUNCPTR (gst_gl_context_gpu_process_activate);
+}
+
+static void
+gst_gl_context_gpu_process_init (GstGLContextGPUProcess * context)
+{
+  context->priv = GST_GL_CONTEXT_GPU_PROCESS_GET_PRIVATE (context);
+}
+
+GstGLContext *
+gst_gl_context_gpu_process_new (GstGLDisplay * display,
+    GstGLAPI gl_api, GstGLProcAddrFunc proc_addr)
+{
+  GstGLContext *context = NULL;
+  GstGLContextEGL *egl_context = NULL;
+  GstGLContextGPUProcess *gpu_context = NULL;
+  GstGLContextClass *context_class = NULL;
+  GstGLWindow *window = NULL;
+  GError *error = NULL;
+  g_return_val_if_fail ((gst_gl_display_get_gl_api (display) & gl_api) !=
+      GST_GL_API_NONE, NULL);
+
+  gpu_context = g_object_new (GST_GL_TYPE_CONTEXT_GPU_PROCESS, NULL);
+
+  egl_context = GST_GL_CONTEXT_EGL (gpu_context);
+  egl_context->gl_api = gl_api;
+
+  context = GST_GL_CONTEXT (gpu_context);
+
+  context->display = display;
+  gst_gl_display_add_context (display, context);
+
+  context_class = GST_GL_CONTEXT_GET_CLASS (context);
+
+  context_class->get_current_context = NULL;
+  context_class->get_proc_address = GST_DEBUG_FUNCPTR (proc_addr);
+
+  gst_gl_context_activate (context, TRUE);
+  gst_gl_context_fill_info (context, &error);
+
+  if (error) {
+    GST_ERROR_OBJECT (context, "Failed to create gpu process context: %s",
+        error->message);
+    g_error_free (error);
+    gst_object_unref (context);
+    return NULL;
+  }
+
+  context->gl_vtable->EGLImageTargetTexture2D =
+      gst_gl_context_get_proc_address (context, "glEGLImageTargetTexture2D");
+
+  if (!context->gl_vtable->EGLImageTargetTexture2D) {
+    GST_ERROR_OBJECT (context, "Cannot find glEGLImageTargetTexture2D");
+    gst_object_unref (context);
+    return NULL;
+  }
+
+  egl_context->eglCreateImage = gst_gl_context_get_proc_address (context,
+    "eglCreateImage");
+  egl_context->eglDestroyImage = gst_gl_context_get_proc_address (context,
+    "eglDestroyImage");
+
+  window = GST_GL_WINDOW (gst_gl_window_gpu_process_new (display));
+  gst_gl_context_set_window (context, window);
+  GST_GL_WINDOW_GET_CLASS (window)->open (window, NULL);
+  gst_object_unref (window);
+
+  return context;
+}
diff --git a/content/media/gstreamer/gpuprocess/gstglcontext_gpu_process.h b/content/media/gstreamer/gpuprocess/gstglcontext_gpu_process.h
new file mode 100644
index 0000000..8c89322
--- /dev/null
+++ b/content/media/gstreamer/gpuprocess/gstglcontext_gpu_process.h
@@ -0,0 +1,74 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef __GST_GL_CONTEXT_GPU_PROCESS_H__
+#define __GST_GL_CONTEXT_GPU_PROCESS_H__
+
+#include <gst/gst.h>
+#include <gst/gl/gstglconfig.h>
+
+#if !GST_GL_HAVE_GLES2
+#error "GstGL with GLES2 support is required"
+#endif
+
+#undef GST_GL_HAVE_OPENGL
+#define GST_GL_HAVE_OPENGL 0
+
+#include <gst/gl/gl.h>
+#include <gst/gl/egl/gstglcontext_egl.h>
+
+G_BEGIN_DECLS
+
+#define GST_GL_TYPE_CONTEXT_GPU_PROCESS (gst_gl_context_gpu_process_get_type())
+#define GST_GL_CONTEXT_GPU_PROCESS(o)                               \
+  (G_TYPE_CHECK_INSTANCE_CAST((o), GST_GL_TYPE_CONTEXT_GPU_PROCESS, \
+                              GstGLContextGPUProcess))
+#define GST_GL_CONTEXT_GPU_PROCESS_CLASS(k)                      \
+  (G_TYPE_CHECK_CLASS_CAST((k), GST_GL_TYPE_CONTEXT_GPU_PROCESS, \
+                           GstGLContextGPUProcessClass))
+#define GST_GL_IS_CONTEXT_GPU_PROCESS(o) \
+  (G_TYPE_CHECK_INSTANCE_TYPE((o), GST_GL_TYPE_CONTEXT_GPU_PROCESS))
+#define GST_GL_IS_CONTEXT_GPU_PROCESS_CLASS(k) \
+  (G_TYPE_CHECK_CLASS_TYPE((k), GST_GL_TYPE_CONTEXT_GPU_PROCESS))
+#define GST_GL_CONTEXT_GPU_PROCESS_GET_CLASS(o)                    \
+  (G_TYPE_INSTANCE_GET_CLASS((o), GST_GL_TYPE_CONTEXT_GPU_PROCESS, \
+                             GstGLContextGPUProcessClass))
+
+typedef struct _GstGLContextGPUProcess GstGLContextGPUProcess;
+typedef struct _GstGLContextGPUProcessPrivate GstGLContextGPUProcessPrivate;
+typedef struct _GstGLContextGPUProcessClass GstGLContextGPUProcessClass;
+
+typedef gpointer (*GstGLProcAddrFunc)(GstGLAPI gl_api, const gchar* name);
+
+/**
+ * GstGLContextGPUProcess:
+ *
+ * Opaque #GstGLContextGPUProcess object
+ */
+struct _GstGLContextGPUProcess {
+  GstGLContextEGL parent;
+
+  /*< private >*/
+  GstGLContextGPUProcessPrivate* priv;
+
+  /*< private >*/
+  gpointer _reserved[GST_PADDING];
+};
+
+struct _GstGLContextGPUProcessClass {
+  GstGLContextEGLClass parent;
+
+  /*< private >*/
+  gpointer _reserved[GST_PADDING];
+};
+
+GType gst_gl_context_gpu_process_get_type(void);
+
+GstGLContext* gst_gl_context_gpu_process_new(GstGLDisplay* display,
+                                             GstGLAPI gl_api,
+                                             GstGLProcAddrFunc proc_addr);
+
+G_END_DECLS
+
+#endif /* __GST_GL_CONTEXT_GPU_PROCESS_H__ */
diff --git a/content/media/gstreamer/gpuprocess/gstgldisplay_gpu_process.c b/content/media/gstreamer/gpuprocess/gstgldisplay_gpu_process.c
new file mode 100644
index 0000000..c1e180d
--- /dev/null
+++ b/content/media/gstreamer/gpuprocess/gstgldisplay_gpu_process.c
@@ -0,0 +1,44 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include "content/media/gstreamer/gpuprocess/gstgldisplay_gpu_process.h"
+
+GST_DEBUG_CATEGORY_STATIC (gst_gl_display_debug);
+#define GST_CAT_DEFAULT gst_gl_display_debug
+
+G_DEFINE_TYPE (GstGLDisplayGPUProcess, gst_gl_display_gpu_process, GST_TYPE_GL_DISPLAY);
+
+static void gst_gl_display_gpu_process_finalize (GObject * object);
+
+static void
+gst_gl_display_gpu_process_class_init (GstGLDisplayGPUProcessClass * klass)
+{
+  G_OBJECT_CLASS (klass)->finalize = gst_gl_display_gpu_process_finalize;
+}
+
+static void
+gst_gl_display_gpu_process_init (GstGLDisplayGPUProcess * display_gpu_process)
+{
+  GstGLDisplay *display = (GstGLDisplay *) display_gpu_process;
+
+  display->type = GST_GL_DISPLAY_TYPE_EGL;
+}
+
+static void
+gst_gl_display_gpu_process_finalize (GObject * object)
+{
+  G_OBJECT_CLASS (gst_gl_display_gpu_process_parent_class)->finalize (object);
+}
+
+GstGLDisplayGPUProcess *
+gst_gl_display_gpu_process_new (void)
+{
+  GST_DEBUG_CATEGORY_GET (gst_gl_display_debug, "gldisplay");
+
+  return g_object_new (GST_TYPE_GL_DISPLAY_GPU_PROCESS, NULL);
+}
diff --git a/content/media/gstreamer/gpuprocess/gstgldisplay_gpu_process.h b/content/media/gstreamer/gpuprocess/gstgldisplay_gpu_process.h
new file mode 100644
index 0000000..8b0a239
--- /dev/null
+++ b/content/media/gstreamer/gpuprocess/gstgldisplay_gpu_process.h
@@ -0,0 +1,52 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef __GST_GL_DISPLAY_GPU_PROCESS_H__
+#define __GST_GL_DISPLAY_GPU_PROCESS_H__
+
+#include <gst/gst.h>
+#include <gst/gl/gstglconfig.h>
+
+#if !GST_GL_HAVE_GLES2
+#error "GstGL with GLES2 support is required"
+#endif
+
+#undef GST_GL_HAVE_OPENGL
+#define GST_GL_HAVE_OPENGL 0
+
+#include <gst/gl/gl.h>
+
+G_BEGIN_DECLS
+
+GType gst_gl_display_gpu_process_get_type(void);
+
+#define GST_TYPE_GL_DISPLAY_GPU_PROCESS (gst_gl_display_gpu_process_get_type())
+#define GST_GL_DISPLAY_GPU_PROCESS(obj)                               \
+  (G_TYPE_CHECK_INSTANCE_CAST((obj), GST_TYPE_GL_DISPLAY_GPU_PROCESS, \
+                              GstGLDisplayGPUProcess))
+#define GST_GL_DISPLAY_GPU_PROCESS_CLASS(klass)                      \
+  (G_TYPE_CHECK_CLASS_CAST((klass), GST_TYPE_GL_DISPLAY_GPU_PROCESS, \
+                           GstGLDisplayGPUProcessClass))
+#define GST_IS_GL_DISPLAY_GPU_PROCESS(obj) \
+  (G_TYPE_CHECK_INSTANCE_TYPE((obj), GST_TYPE_GL_DISPLAY_GPU_PROCESS))
+#define GST_IS_GL_DISPLAY_GPU_PROCESS_CLASS(klass) \
+  (G_TYPE_CHECK_CLASS_TYPE((klass), GST_TYPE_GL_DISPLAY_GPU_PROCESS))
+#define GST_GL_DISPLAY_GPU_PROCESS_CAST(obj) ((GstGLDisplayGPUProcess*)(obj))
+
+typedef struct _GstGLDisplayGPUProcess GstGLDisplayGPUProcess;
+typedef struct _GstGLDisplayGPUProcessClass GstGLDisplayGPUProcessClass;
+
+struct _GstGLDisplayGPUProcess {
+  GstGLDisplay parent;
+};
+
+struct _GstGLDisplayGPUProcessClass {
+  GstGLDisplayClass object_class;
+};
+
+GstGLDisplayGPUProcess* gst_gl_display_gpu_process_new(void);
+
+G_END_DECLS
+
+#endif /* __GST_GL_DISPLAY_GPU_PROCESS_H__ */
diff --git a/content/media/gstreamer/gpuprocess/gstglwindow_gpu_process.c b/content/media/gstreamer/gpuprocess/gstglwindow_gpu_process.c
new file mode 100644
index 0000000..39f273d
--- /dev/null
+++ b/content/media/gstreamer/gpuprocess/gstglwindow_gpu_process.c
@@ -0,0 +1,48 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#define GLIB_DISABLE_DEPRECATION_WARNINGS
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include "content/media/gstreamer/gpuprocess/gstglwindow_gpu_process.h"
+
+#define GST_GL_WINDOW_GPU_PROCESS_GET_PRIVATE(o)  \
+  (G_TYPE_INSTANCE_GET_PRIVATE((o), GST_GL_TYPE_WINDOW_GPU_PROCESS, GstGLWindowGPUProcessPrivate))
+
+#define GST_CAT_DEFAULT gst_gl_window_debug
+
+#define gst_gl_window_gpu_process_parent_class parent_class
+G_DEFINE_TYPE (GstGLWindowGPUProcess, gst_gl_window_gpu_process,
+    GST_GL_TYPE_WINDOW);
+
+struct _GstGLWindowGPUProcessPrivate
+{
+  int empty;
+};
+
+static void
+gst_gl_window_gpu_process_class_init (GstGLWindowGPUProcessClass * klass)
+{
+  g_type_class_add_private (klass, sizeof (GstGLWindowGPUProcessPrivate));
+}
+
+static void
+gst_gl_window_gpu_process_init (GstGLWindowGPUProcess * window)
+{
+  window->priv = GST_GL_WINDOW_GPU_PROCESS_GET_PRIVATE (window);
+}
+
+GstGLWindowGPUProcess *
+gst_gl_window_gpu_process_new (GstGLDisplay * display)
+{
+  GstGLWindowGPUProcess *window =
+      g_object_new (GST_GL_TYPE_WINDOW_GPU_PROCESS, NULL);
+
+  GST_GL_WINDOW (window)->display = gst_object_ref (display);
+
+  return window;
+}
diff --git a/content/media/gstreamer/gpuprocess/gstglwindow_gpu_process.h b/content/media/gstreamer/gpuprocess/gstglwindow_gpu_process.h
new file mode 100644
index 0000000..f571245
--- /dev/null
+++ b/content/media/gstreamer/gpuprocess/gstglwindow_gpu_process.h
@@ -0,0 +1,75 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef __GST_GL_WINDOW_GPU_PROCESS_H__
+#define __GST_GL_WINDOW_GPU_PROCESS_H__
+
+#include <gst/gst.h>
+#include <gst/gl/gstglconfig.h>
+
+#if !GST_GL_HAVE_GLES2
+#error "GstGL with GLES2 support is required"
+#endif
+
+#undef GST_GL_HAVE_OPENGL
+#define GST_GL_HAVE_OPENGL 0
+
+#include <gst/gl/gl.h>
+#include "gstglcontext_gpu_process.h"
+
+G_BEGIN_DECLS
+
+#define GST_GL_TYPE_WINDOW_GPU_PROCESS (gst_gl_window_gpu_process_get_type())
+#define GST_GL_WINDOW_GPU_PROCESS(o)                               \
+  (G_TYPE_CHECK_INSTANCE_CAST((o), GST_GL_TYPE_WINDOW_GPU_PROCESS, \
+                              GstGLWindowGPUProcess))
+#define GST_GL_WINDOW_GPU_PROCESS_CLASS(k)                      \
+  (G_TYPE_CHECK_CLASS_CAST((k), GST_GL_TYPE_WINDOW_GPU_PROCESS, \
+                           GstGLWindowGPUProcessClass))
+#define GST_GL_IS_WINDOW_GPU_PROCESS(o) \
+  (G_TYPE_CHECK_INSTANCE_TYPE((o), GST_GL_TYPE_WINDOW_GPU_PROCESS))
+#define GST_GL_IS_WINDOW_GPU_PROCESS_CLASS(k) \
+  (G_TYPE_CHECK_CLASS_TYPE((k), GST_GL_TYPE_WINDOW_GPU_PROCESS))
+#define GST_GL_WINDOW_GPU_PROCESS_GET_CLASS(o)                    \
+  (G_TYPE_INSTANCE_GET_CLASS((o), GST_GL_TYPE_WINDOW_GPU_PROCESS, \
+                             GstGLWindowGPUProcessClass))
+
+typedef struct _GstGLWindowGPUProcess GstGLWindowGPUProcess;
+typedef struct _GstGLWindowGPUProcessPrivate GstGLWindowGPUProcessPrivate;
+typedef struct _GstGLWindowGPUProcessClass GstGLWindowGPUProcessClass;
+
+/**
+ * GstGLWindowGPUProcess:
+ *
+ * Opaque #GstGLWindowGPUProcess object
+ */
+struct _GstGLWindowGPUProcess {
+  GstGLWindow parent;
+
+  /*< private >*/
+  GstGLWindowGPUProcessPrivate* priv;
+
+  /*< private >*/
+  gpointer _reserved[GST_PADDING];
+};
+
+/**
+ * GstGLWindowGPUProcessClass:
+ *
+ * Opaque #GstGLWindowGPUProcessClass object
+ */
+struct _GstGLWindowGPUProcessClass {
+  GstGLWindowClass parent_class;
+
+  /*< private >*/
+  gpointer _reserved[GST_PADDING];
+};
+
+GType gst_gl_window_gpu_process_get_type(void);
+
+GstGLWindowGPUProcess* gst_gl_window_gpu_process_new(GstGLDisplay* display);
+
+G_END_DECLS
+
+#endif /* __GST_GL_WINDOW_GPU_PROCESS_H__ */
diff --git a/content/media/gstreamer/gst_chromium_aes_ctr.cc b/content/media/gstreamer/gst_chromium_aes_ctr.cc
new file mode 100644
index 0000000..18b2dc9
--- /dev/null
+++ b/content/media/gstreamer/gst_chromium_aes_ctr.cc
@@ -0,0 +1,77 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "content/media/gstreamer/gst_chromium_aes_ctr.h"
+
+#include <openssl/aes.h>
+#include <string.h>
+#include <gst/gst.h>
+
+struct _AesCtrState {
+  volatile gint refcount;
+  AES_KEY key;
+  unsigned char ivec[16];
+  unsigned int num;
+  unsigned char ecount[16];
+};
+
+AesCtrState* chromium_aes_ctr_decrypt_new(GBytes* key, GBytes* iv) {
+  unsigned char* buf;
+  gsize iv_length;
+  AesCtrState* state;
+
+  g_return_val_if_fail(key != NULL, NULL);
+  g_return_val_if_fail(iv != NULL, NULL);
+
+  state = g_slice_new(AesCtrState);
+  if (!state) {
+    GST_ERROR("Failed to allocate AesCtrState");
+    return NULL;
+  }
+
+  g_assert(g_bytes_get_size(key) == 16);
+  AES_set_encrypt_key((const unsigned char*)g_bytes_get_data(key, NULL),
+                      8 * g_bytes_get_size(key), &state->key);
+
+  buf = (unsigned char*)g_bytes_get_data(iv, &iv_length);
+  state->num = 0;
+  memset(state->ecount, 0, 16);
+  if (iv_length == 8) {
+    memset(state->ivec + 8, 0, 8);
+    memcpy(state->ivec, buf, 8);
+  } else {
+    memcpy(state->ivec, buf, 16);
+  }
+
+  return state;
+}
+
+AesCtrState* chromium_aes_ctr_decrypt_ref(AesCtrState* state) {
+  g_return_val_if_fail(state != NULL, NULL);
+
+  g_atomic_int_inc(&state->refcount);
+
+  return state;
+}
+
+void chromium_aes_ctr_decrypt_unref(AesCtrState* state) {
+  g_return_if_fail(state != NULL);
+
+  if (g_atomic_int_dec_and_test(&state->refcount)) {
+    g_slice_free(AesCtrState, state);
+  }
+}
+
+gboolean chromium_aes_ctr_decrypt_ip(AesCtrState* state,
+                                     unsigned char* data,
+                                     int length) {
+  AES_ctr128_encrypt(data, data, length, &state->key, state->ivec,
+                     state->ecount, &state->num);
+  return TRUE;
+}
+
+G_DEFINE_BOXED_TYPE(AesCtrState,
+                    chromium_aes_ctr,
+                    (GBoxedCopyFunc)chromium_aes_ctr_decrypt_ref,
+                    (GBoxedFreeFunc)chromium_aes_ctr_decrypt_unref);
diff --git a/content/media/gstreamer/gst_chromium_aes_ctr.h b/content/media/gstreamer/gst_chromium_aes_ctr.h
new file mode 100644
index 0000000..3dc78f4
--- /dev/null
+++ b/content/media/gstreamer/gst_chromium_aes_ctr.h
@@ -0,0 +1,24 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_MEDIA_GSTREAMER_AES_H_
+#define CONTENT_MEDIA_GSTREAMER_AES_H_
+
+#include <glib.h>
+
+G_BEGIN_DECLS
+
+typedef struct _AesCtrState AesCtrState;
+
+AesCtrState* chromium_aes_ctr_decrypt_new(GBytes* key, GBytes* iv);
+AesCtrState* chromium_aes_ctr_decrypt_ref(AesCtrState* state);
+void chromium_aes_ctr_decrypt_unref(AesCtrState* state);
+
+gboolean chromium_aes_ctr_decrypt_ip(AesCtrState* state,
+                                     unsigned char* data,
+                                     int length);
+
+G_END_DECLS
+
+#endif  // CONTENT_MEDIA_GSTREAMER_AES_H_
